using System;
using ThinkGeo.MapSuite.Core;

namespace CSSamples
{
    public partial class DrawThematicFeatures : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#E5E3DF"));
            Map1.CurrentExtent = new RectangleShape(-140, 60, 140, -60);
            Map1.MapUnit = GeographyUnit.DecimalDegree;

            ClassBreakStyle classBreakStyle = new ClassBreakStyle("RentBalance");
            ClassBreak cb1 = new ClassBreak(double.MinValue, AreaStyles.Grass1);
            //cb1.DefaultTextStyle = TextStyles.CreateSimpleTextStyle("ParcelNumber", "Arial", 10, DrawingFontStyles.Regular, GeoColor.StandardColors.Red, 0, -12);

            classBreakStyle.ClassBreaks.Add(cb1);

            ClassBreak cb2 = new ClassBreak(1000000, AreaStyles.Evergreen2);
            cb2.DefaultTextStyle = TextStyles.CreateSimpleTextStyle("ParcelNumber", "Arial", 10, DrawingFontStyles.Regular, GeoColor.StandardColors.Red, 0, -12);

            classBreakStyle.ClassBreaks.Add(cb2);

            ClassBreak cb3 = new ClassBreak(10000000, AreaStyles.Evergreen1);
            cb3.DefaultTextStyle = TextStyles.CreateSimpleTextStyle("ParcelNumber", "Arial", 10, DrawingFontStyles.Regular, GeoColor.StandardColors.Red, 0, -12);

            classBreakStyle.ClassBreaks.Add(cb3);

            ClassBreak cb4 = new ClassBreak(50000000, AreaStyles.Crop1);
            cb4.DefaultTextStyle = TextStyles.CreateSimpleTextStyle("ParcelNumber", "Arial", 10, DrawingFontStyles.Regular, GeoColor.StandardColors.Red, 0, -12);

            classBreakStyle.ClassBreaks.Add(cb4);
            ClassBreak cb5 = new ClassBreak(100000000, AreaStyles.Forest1);
            cb5.DefaultTextStyle = TextStyles.CreateSimpleTextStyle("ParcelNumber", "Arial", 10, DrawingFontStyles.Regular, GeoColor.StandardColors.Red, 0, -12);

            classBreakStyle.ClassBreaks.Add(cb5);

            ShapeFileFeatureLayer worldLayer = new ShapeFileFeatureLayer(MapPath("~/SampleData/world/cntry02.shp"));
            worldLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(classBreakStyle);
            worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            worldLayer.FeatureSource.CustomColumnFetch += new EventHandler<CustomColumnFetchEventArgs>(FeatureSource_CustomColumnFetch);

            Map1.StaticOverlay.Layers.Add("WorldLayer", worldLayer);
        }

        void FeatureSource_CustomColumnFetch(object sender, CustomColumnFetchEventArgs e)
        {
            // Get ParcelNumber and RentBalance depent on the feature id which is the line number of dBASE file.
            string parcelNubmer = e.Id;
            string rentBalance = Convert.ToString(Convert.ToInt32(e.Id) * 1000000);

            switch (e.ColumnName)
            {
                case "ParcelNumber":
                    e.ColumnValue = parcelNubmer;
                    break;
                case "RentBalance":
                    e.ColumnValue = rentBalance;
                    break;
                default:
                    break;
            }
        }
    }
}
